program exercise11
  implicit none

  double precision :: a, b, c, disc, x1, x2

  complex*16, parameter :: iunit  = (0.0d0, 1.0d0) ! 虚数単位
  complex*16 :: x1c, x2c

  print *, "solution of the quadratic equation a*x**2+b*x+c=0" 
  print *, "enter a, b, c "
  ! 標準入力からa, b, cを読み込む
  read(*,*) a, b, c

  if( abs(a) < 1.0d-15) then    !aがゼロの場合

     if( abs(b) < 1.0d-15) then !bがゼロの場合

        if( abs(c) < 1.0d-15) then !cがゼロの場合

           ! a=b=c=0の場合は解は不定
           print *, "any x can be a solution."

        else

           !a=b=0でcがゼロでなければ解は存在しない
           print *, "solutions do not exist"

        end if

     else ! bがゼロでない場合、bx+c=0の１次方程式

        x1 = -c/b
        print *, " x = ", x1
        print *, "ax^2+bx+c = ", a*x1**2+b*x1+c !解がもとの方程式を満たすかチェック
        
     end if

  else  ! aがゼロではない場合

     !判別式
     disc = b**2 - 4.0d0*a*c
       
     if( disc >= 0.0d0 ) then  !判別式が正またはゼロの場合

        !実数解が２つ
        x1 = (-b + sqrt(disc)) / (2.0d0*a)
        x2 = (-b - sqrt(disc)) / (2.0d0*a)

        !解を出力
        print *, " x1 = ", x1, " x2 = ", x2

        !解がもとの方程式を満たすかチェック
        print *, "ax^2+bx+c = ", a*x1**2+b*x1+c 
        print *, "ax^2+bx+c = ", a*x2**2+b*x2+c

     else !判別式が負の場合

        !複素数解が２つ
        x1c = ( - b + sqrt(-disc)*iunit) / (2.0d0*a)
        x2c = ( - b - sqrt(-disc)*iunit) / (2.0d0*a)

        print *, " x1 = ", x1c
        print *, " x2 = ", x2c

        !解がもとの方程式を満たすかチェック
        print *, "ax^2+bx+c = ", a*x1c**2+b*x1c+c
        print *, "ax^2+bx+c = ", a*x2c**2+b*x2c+c
        
     end if

  end if
     
end program exercise11
